/*
 * callbacks.h
 * byojeopardy
 *
 * by Doug Wolfe
 * doug@wolfescience.com 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRA
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>
#include <libxml/xmlwriter.h>

enum {BYOJ_TOPIC, BYOJ_VALUE, BYOJ_QUESTION, BYOJ_ANSWER, BYOJ_DAILY_DOUBLE};
enum {BYOJ_COLUMN_TOPIC, BYOJ_COLUMN_TOPIC_EDITABLE, BYOJ_COLUMN_QUESTION, BYOJ_COLUMN_QUESTION_EDITABLE, BYOJ_COLUMN_TYPE};

GtkWidget *byoj_window_main;
gchar *current_filename;
gboolean byoj_answer_in_form_of_question;

xmlDocPtr 
byoj_write_xmldocptr(GtkWidget *byoj_treeview);

gboolean
byoj_read_file(gchar *filename, GtkWidget *widget);

GtkTreeIter
byoj_add_topic (GtkTreeStore *store, gchar *topic_string, gint position);

GtkTreeIter 
byoj_add_value (GtkTreeStore *store, GtkTreeIter topic_iter, gchar *value_string, gchar *question_string, gchar *answer_string, gint position);

GtkTreeIter 
byoj_add_daily_double_topic (GtkTreeStore *store);

GtkTreeIter 
byoj_add_daily_double (GtkTreeStore *store, gchar *value_string, gchar *question_string, gchar *answer_string);

void
byoj_setup_treeview (GtkWidget *byoj_treeview);

void
byoj_menuitem_open_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_exit_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_fullscreen_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_about_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_edit_on_activate (GtkMenuItem *menuitem, gpointer user_data);

gboolean
byoj_window_main__on_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);

void
byoj_menuitem_new_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_show_board_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_button_home_clicked (GtkButton *button, gpointer user_data);

void
byoj_button_question_clicked (GtkButton *button, gpointer user_data);

void
byoj_menuitem_save_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_saveas_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_toolbutton_save_clicked (GtkToolButton *toolbutton, gpointer user_data);

void
byoj_toolbutton_saveas_clicked (GtkToolButton *toolbutton, gpointer user_data);

void
byoj_toolbutton_edit_label_clicked (GtkToolButton *toolbutton, gpointer user_data);

void
byoj_toolbutton_add_topic_clicked (GtkToolButton *toolbutton, gpointer user_data);

void
byoj_toolbutton_add_value_clicked (GtkToolButton *toolbutton, gpointer user_data);

void
byoj_toolbutton_add_daily_double_clicked (GtkToolButton *toolbutton, gpointer user_data);

void
byoj_toolbutton_delete_clicked (GtkToolButton *toolbutton, gpointer user_data);

void
byoj_menuitem_rebuild_board_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_export_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_preferences_on_activate (GtkMenuItem *menuitem, gpointer user_data);

gboolean
byoj_window_main_on_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);

void
byoj_menuitem_undo_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_redo_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_edit_label_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_add_topic_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_add_value_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_add_daily_double_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_delete_on_activate (GtkMenuItem *menuitem, gpointer user_data);

int
byoj_has_daily_double (GtkTreeView *byoj_treeview);

void
byoj_menuitem_cut_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_copy_on_activate (GtkMenuItem *menuitem, gpointer user_data);

void
byoj_menuitem_paste_on_activate (GtkMenuItem *menuitem, gpointer user_data);
