/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */
#include <gtk/gtk.h>

#include "interface.h"
#include "callbacks.h"

#include <xhtmlite/xhtmlite_module/support.h>

#ifdef G_OS_WIN32
 #  include "config.h"
#else
 #ifdef HAVE_CONFIG_H
 #  include <config.h>
 #endif
#endif

gchar *package_data_dir;

#ifdef G_OS_WIN32
 #include <windows.h>
#endif
#include "byojundo.h"
#include "byojmusic.h"

int
main (int argc, char *argv[])
{
#ifdef G_OS_WIN32
  gchar *package_prefix = g_win32_get_package_installation_directory (NULL, NULL);
  package_data_dir = package_prefix;//g_build_filename (package_prefix, "share", NULL);
#else
 package_data_dir = g_build_filename (PACKAGE_DATA_DIR, PACKAGE, NULL);
#endif

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (PACKAGE, "UTF-8");
  textdomain (PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);
  
  gchar *pixmap_dir;
  pixmap_dir = g_build_filename (package_data_dir, "pixmaps", NULL);
  printf("Pixmaps Directory:%s\n", pixmap_dir);
  add_pixmap_directory (pixmap_dir);
  
  pixmap_dir = g_build_filename (package_data_dir, "xhtmlite/pixmaps", NULL);
  printf("Pixmaps Directory:%s\n", pixmap_dir);
  add_pixmap_directory (pixmap_dir);
  g_free (pixmap_dir);


  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
	byoj_window_main = create_byoj_window_main ();
	GtkWidget *byoj_treeview = lookup_widget(byoj_window_main, "byoj_treeview");
	byoj_setup_treeview (byoj_treeview);
	byoj_undo_setup(byoj_treeview);
  
  gtk_widget_show (byoj_window_main);
  
  printf("Arguments passed:%s, %s\n", argv[0], argv[1]);
  if (argv[1] != NULL)
  {
    byoj_read_file(argv[1], byoj_window_main);
  }
  //gtk_window_fullscreen(byoj_window_main);
  //g_signal_connect ((gpointer) byoj_window_main, "destroy", G_CALLBACK(gtk_main_quit), NULL);
  byoj_music_dailydouble_start();
  gtk_main ();
  printf("quitting\n");

#ifdef G_OS_WIN32
  g_free (package_prefix);
  g_free (package_data_dir);
//  g_free (package_locale_dir);
#endif

  return 0;
}
#ifdef _MSC_VER
#include <windows.h>

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow)
{
  return main (__argc, __argv);
}
#endif
