/*
 * xhtmltag.c
 * xhtmlite
 *
 * by Doug Wolfe
 * doug@wolfescience.com 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.,  59 Temple Place - Suite 330, Cambridge, MA 02139, USA.
 *
 */

#include <gtk/gtk.h>
#ifdef G_OS_WIN32
 #include <windows.h>
#endif

#include "support.h"

static void
xhtmlite_follow_www_link(GtkTextTag *tag)
{
	gchar *link = g_object_get_data(G_OBJECT(tag), "link");
	if(g_str_get_length(link) > 0)
	{
		xhtmlite_open_website(link);
	}
}

static gint tag_event_handler (GtkTextTag *tag, GtkWidget *widget, GdkEvent *event,
			       const GtkTextIter *iter, gpointer user_data)
{
  	GdkEventButton *event_button = (GdkEventButton *) event;
	//gint char_index;
	//char_index = gtk_text_iter_get_offset (iter);
	
	switch (event->type)
	{
		case GDK_MOTION_NOTIFY:
			//printf ("Motion event at char %d tag `%s'\n", char_index, tag->name);
			break;

		case GDK_BUTTON_PRESS:
			//printf ("Button press at char %d tag `%s'\n", char_index, tag->name);
			break;

		case GDK_2BUTTON_PRESS:
			//printf ("Double click at char %d tag `%s'\n", char_index, tag->name);
			break;
 
		case GDK_3BUTTON_PRESS:
			//printf ("Triple click at char %d tag `%s'\n", char_index, tag->name);
			break;
 
		case GDK_BUTTON_RELEASE:
			if ((event_button->button == 1) ) 
			{
				GtkTextIter start, end;
				/* we shouldn't open a URL if the user has selected something: */
				if (gtk_text_buffer_get_selection_bounds(
					gtk_text_iter_get_buffer(iter),	&start, &end))
					return FALSE;

				/* A link was clicked*/
				xhtmlite_follow_www_link(tag);
			}
			else if(event_button->button == 3) 
			{
				//~ GtkWidget *img, *item, *menu;
				//~ gchar *url = g_strdup(g_object_get_data(G_OBJECT(tag), "link"));

				//~ /* Don't want the tooltip around if user right-clicked on link */
				//~ /*if (GTK_IMHTML(imhtml)->tip_window) 
				//~ {
					//~ gtk_widget_destroy(GTK_IMHTML(imhtml)->tip_window);
					//~ GTK_IMHTML(imhtml)->tip_window = NULL;
				//~ }
				//~ if (GTK_IMHTML(imhtml)->tip_timer) 
				//~ {
					//~ g_source_remove(GTK_IMHTML(imhtml)->tip_timer);
					//~ GTK_IMHTML(imhtml)->tip_timer = 0;
				//~ }
				//~ if (GTK_IMHTML(imhtml)->editable)
					//~ gdk_window_set_cursor(event_button->window, GTK_IMHTML(imhtml)->text_cursor);
				//~ else
					//~ gdk_window_set_cursor(event_button->window, GTK_IMHTML(imhtml)->arrow_cursor);
				//~ */	
				//~ menu = gtk_menu_new();
				//~ g_object_set_data(G_OBJECT(menu), "x-imhtml-url-data", url);

				//~ /* buttons and such */

				//~ if (!strncmp(url, "mailto:", 7))
				//~ {
					//~ /* Copy E-Mail Address */
					//~ img = gtk_image_new_from_stock(GTK_STOCK_COPY,
										   //~ GTK_ICON_SIZE_MENU);
					//~ item = gtk_image_menu_item_new_with_mnemonic(
						//~ _("_Copy E-Mail Address"));
					//~ gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), img);
					//~ //g_signal_connect(G_OBJECT(item), "activate",
					//~ //		 G_CALLBACK(url_copy), tempdata->url + 7);
					//~ gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
				//~ }
				//~ else
				//~ {
					//~ /* Copy Link Location */
					//~ img = gtk_image_new_from_stock(GTK_STOCK_COPY,
										   //~ GTK_ICON_SIZE_MENU);
					//~ item = gtk_image_menu_item_new_with_mnemonic(_("_Copy Link Location"));
					//~ gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), img);
					//~ //g_signal_connect(G_OBJECT(item), "activate",
					//~ //		 G_CALLBACK(url_copy), tempdata->url);
					//~ gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);

					//~ /* Open Link in Browser */
					//~ img = gtk_image_new_from_stock(GTK_STOCK_JUMP_TO,
										   //~ GTK_ICON_SIZE_MENU);
					//~ item = gtk_image_menu_item_new_with_mnemonic(_("_Open Link in Browser"));
					//~ gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), img);
					//~ //g_signal_connect(G_OBJECT(item), "activate",
					//~ //		 G_CALLBACK(url_open), tempdata);
					//~ gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
				//~ }

				//~ gtk_widget_show_all(menu);
				//~ gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL,
						//~ event_button->button, event_button->time);
			}
			break;

		case GDK_KEY_PRESS:
		case GDK_KEY_RELEASE:
			break;
      
  		case GDK_NOTHING:
  		case GDK_DELETE:
  		case GDK_DESTROY:
  		case GDK_EXPOSE:
  		case GDK_ENTER_NOTIFY:
  		case GDK_LEAVE_NOTIFY:
  		case GDK_FOCUS_CHANGE:
  		case GDK_CONFIGURE:
  		case GDK_MAP:
  		case GDK_UNMAP:
  		case GDK_PROPERTY_NOTIFY:
  		case GDK_SELECTION_CLEAR:
  		case GDK_SELECTION_REQUEST:
  		case GDK_SELECTION_NOTIFY:
  		case GDK_PROXIMITY_IN:
  		case GDK_PROXIMITY_OUT:
  		case GDK_DRAG_ENTER:
  		case GDK_DRAG_LEAVE:
  		case GDK_DRAG_MOTION:
  		case GDK_DRAG_STATUS:
  		case GDK_DROP_START:
  		case GDK_DROP_FINISHED:
  		case GDK_CLIENT_EVENT:
  		case GDK_VISIBILITY_NOTIFY:
  		case GDK_NO_EXPOSE:
  		case GDK_SCROLL:
  		case GDK_WINDOW_STATE:
  		case GDK_SETTING:
			break;
		default:
			break;
	}

	return FALSE;
}

void xhtmlite_setup_tag (GtkTextTagTable *table, GtkTextTag *tag)
{
	gtk_text_tag_table_add (table, tag);
	g_signal_connect (tag,
			"event",
			G_CALLBACK (tag_event_handler),
			NULL);
}

void xhtmlite_fill_tagtable (GtkTextTagTable *table)
{
	GtkTextTag *tag;

	tag = gtk_text_tag_new   ("u"); //underline
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "underline", PANGO_UNDERLINE_SINGLE,
		      NULL);

	tag = gtk_text_tag_new   ("del"); //strikethrough
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "strikethrough", TRUE,
		      NULL);

	tag = gtk_text_tag_new   ("b"); //bold
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "weight", PANGO_WEIGHT_BOLD,
		      NULL);

	tag = gtk_text_tag_new   ("i"); //italic
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "style", PANGO_STYLE_ITALIC,
		      NULL);

	tag = gtk_text_tag_new   ("sup"); //superscript
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "rise", PANGO_SCALE * 6, //20 for byojeopardy_small, medium and large fonts
		      "size", PANGO_SCALE * 8,
		      NULL);

	tag = gtk_text_tag_new   ("sub"); //subscript
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "rise", PANGO_SCALE * -6,  //-20 for byojeopardy_small, medium and large fonts
		      "size", PANGO_SCALE * 8,
		      NULL);

	tag = gtk_text_tag_new   ("center"); //center
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "justification", GTK_JUSTIFY_CENTER,
		      NULL);

	tag = gtk_text_tag_new   ("right"); //right
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "justification", GTK_JUSTIFY_RIGHT,
		      NULL);

	tag = gtk_text_tag_new   ("left"); //left
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "justification", GTK_JUSTIFY_LEFT,
		      NULL);

	tag = gtk_text_tag_new   ("byojeopardy_small"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 48,
		      NULL);
		      
	tag = gtk_text_tag_new   ("byojeopardy_medium"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 72,
		      NULL);
 
	tag = gtk_text_tag_new   ("byojeopardy_large"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 96,
		      NULL);

	tag = gtk_text_tag_new   ("span font-size='xx-small'"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 7,   //1000 for byojeopardy
		      NULL);
	g_object_set_data(G_OBJECT(tag), "font-size_absolute", "xx-small");

	tag = gtk_text_tag_new   ("span font-size='x-small'"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 8,   //20000 for byojeopardy
		      NULL);
	g_object_set_data(G_OBJECT(tag), "font-size_absolute", "x-small");

	tag = gtk_text_tag_new   ("span font-size='small'"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 10,   //40000 for byojeopardy
		      NULL);
	g_object_set_data(G_OBJECT(tag), "font-size_absolute", "small");
		      
	tag = gtk_text_tag_new   ("span font-size='medium'"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 12,   //60000 for byojeopardy
		      NULL);
	g_object_set_data(G_OBJECT(tag), "font-size_absolute", "medium");
 
	tag = gtk_text_tag_new   ("span font-size='large'"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 16,    //80000 for byojeopardy
		      NULL);
	g_object_set_data(G_OBJECT(tag), "font-size_absolute", "large");

	tag = gtk_text_tag_new   ("span font-size='x-large'"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 24,    //100000 for byojeopardy
		      NULL);
	g_object_set_data(G_OBJECT(tag), "font-size_absolute", "x-large");

	tag = gtk_text_tag_new   ("span font-size='xx-large'"); //byojeopardy_question
	xhtmlite_setup_tag(table,tag);
	g_object_set (tag,
		      "size", PANGO_SCALE * 32,    //120000 for byojeopardy
		      NULL);
	g_object_set_data(G_OBJECT(tag), "font-size_absolute", "xx-large");
}

gint xhtmlite_open_website(const char *filename)
{
	gint ret = 0;
 	#ifdef G_OS_WIN32
		//system(g_strdup_printf("%s > NULL", filename)); //locks up the application at this point
		ShellExecute(HWND_DESKTOP, "open", filename, NULL, NULL, SW_SHOWNORMAL); //works well for windows
	ret = 1;
	#else
		GError *error = NULL;

		gchar * commandname= g_strdup("sensible-browser");  //default
		#ifdef HAVE_GNOME
			commandname = g_strdup("gnome-open");
		#elif HAVE_KDE
			commandname = g_strdup("kfmclient exec");
		#endif
		gchar *command[] = {commandname, g_strdup (filename), NULL};
		ret = g_spawn_async (NULL, command, NULL, G_SPAWN_SEARCH_PATH,
                          NULL, NULL, NULL, &error);
		if(error)
		{
			printf("Error: Opening File with command '%s'\n", commandname);
		}
	#endif
	return ret;
}
